function editmod(par)
%function for editing model
global PRECISION;
global colorset;
if(par==0)%init
   global A B Ts;
   if((isempty(A)~=1)&(isempty(B)~=1))
		A2=A;
	   B2=B;
      d=0;
		%remove zeros in front of polynoms (they are for nothing)
		while(abs(A2(1))<PRECISION) A2=A2(2:length(A2));end;
		while(abs(B2(1))<PRECISION) B2=B2(2:length(B2));end;
		%transformation from TF(z) to TF(z^-1)
		na=length(A2)-1;
		nb=length(B2)-1;
		if(na>nb)
		   %remove zeros at the end of polynom
	      while(abs(A2(length(A2)))<PRECISION) A2=A2(1:(length(A2)-1));end;
			while(abs(B2(length(B2)))<PRECISION) B2=B2(1:(length(B2)-1));end;
		   zr=na-nb;%delay of B, if =1, d=0,because for B allways b0=0;
         d=zr-1;%delay
	      na=length(A2)-1;
         nb=length(B2);
         A2=A2(2:length(A2));
		elseif(na<nb)
	      %remove zeros at the end of polynom
	      while(abs(A2(length(A2)))<PRECISION) A2=A2(1:(length(A2)-1));end;      
			while(abs(B2(length(B2)))<PRECISION) B2=B2(1:(length(B2)-1));end;
		   zr=zeros(1,nb-na);
	      A2=[zr A2];
	      na=length(A2)-1;
	      nb=length(B2);
	   end;

      sA=num2str(A2);
      sB=num2str(B2);
      sd=num2str(d);
   else 
      sA='';
      sB='';
      sd='0';
	end;
   if(isempty(Ts)~=1) sTs=num2str(Ts);else sTs='';end;
   global h0;
   set(h0,'Unit','pixel');
   pmain=get(h0,'Position');
   set(h0,'Unit','point');
   ped=[446 55 560 325];
   ped(1)=pmain(1)+(pmain(3)-ped(3))/2;
   ped(2)=pmain(2)+(pmain(4)-ped(4))/2;
%create window
hed = dialog('Color',getfield(colorset,'Background'), ...
	'MenuBar','none', ...
   'Position',ped, ...
   'Name','Current Model', ...
   'Deletefcn','editmod(2);', ...
	'Tag','Fig1');
hed_a = uicontrol('Parent',hed, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[5.25 122.25 401.25 15], ...
	'String',sA, ...
	'Style','edit', ...
	'Tag','Acoeff');
hbut_ok = uicontrol('Parent',hed, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[360.75 16.5 45 15], ...
   'String','OK', ...
   'Callback','editmod(1);', ...
	'Tag','okbut');
h1 = uicontrol('Parent',hed, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontSize',10, ...
	'FontWeight','bold', ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[5.25 137.25 141.75 15], ...
	'String','Coefficients of A', ...
	'Style','text', ...
	'Tag','CoefA');
h1 = uicontrol('Parent',hed, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[5.25 107.25 184.5 13.5], ...
	'String','Enter coefficients from a1 to aNA divided by space', ...
	'Style','text', ...
	'Tag','notA');
h1 = uicontrol('Parent',hed, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[5.25 57 184.5 13.5], ...
	'String','Enter coefficients from b1 to bNB divided by space', ...
	'Style','text', ...
	'Tag','notB');
h1 = uicontrol('Parent',hed, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontSize',10, ...
	'FontWeight','bold', ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[5.25 87 141.75 15], ...
	'String','Cefficients of B', ...
	'Style','text', ...
	'Tag','coefB');
hed_b = uicontrol('Parent',hed, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[5.25 72 401.25 15], ...
	'String',sB, ...
	'Style','edit', ...
	'Tag','CoefB');
hed_samp = uicontrol('Parent',hed, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
   'ListboxTop',0, ...
	'HorizontalAlignment','left', ...
	'Position',[90.75 30 53.25 15], ...
   'Style','edit', ...
   'String',sTs, ...
	'Tag','Sampltime');
h1 = uicontrol('Parent',hed, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontSize',10, ...
	'FontWeight','bold', ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[6 30 84.75 15], ...
	'String','Sampling Time:', ...
	'Style','text', ...
	'Tag','EditText2');
hbut_can = uicontrol('Parent',hed, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[297 16.5 45 15], ...
   'String','Cancel', ...
   'CallBack','close;', ...
	'Tag','Canc');
h1 = uicontrol('Parent',hed, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontSize',10, ...
	'FontWeight','bold', ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[38.25 10.5 51.75 15], ...
	'String','Delay d:', ...
	'Style','text', ...
	'Tag','EditText2');
hed_dam = uicontrol('Parent',hed, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
   'ListboxTop',0, ...
	'HorizontalAlignment','left', ...
	'Position',[90 10.5 53.25 15], ...
   'Style','edit', ...
   'String',sd, ...
	'Tag','Damping');
h1 = axes('Parent',hed, ...
	'Units','pixels', ...
	'Box','on', ...
	'CameraUpVector',[0 1 0], ...
	'Color',[1 1 1], ...
	'Position',[130 219 307 88], ...
	'Tag','picture', ...
	'XColor',[0 0 0], ...
	'XTickMode','manual', ...
	'YColor',[0 0 0], ...
	'YTickMode','manual', ...
   'ZColor',[0 0 0]);
hpic=h1;
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',[0.4967320261437909 -0.09195402298850586 9.160254037844386], ...
	'Tag','Axes1Text4', ...
	'VerticalAlignment','cap');
set(get(h2,'Parent'),'XLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',[-0.02287581699346403 0.482758620689655 9.160254037844386], ...
	'Rotation',90, ...
	'Tag','Axes1Text3', ...
	'VerticalAlignment','baseline');
set(get(h2,'Parent'),'YLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','right', ...
	'Position',[-0.4248366013071895 1.206896551724138 9.160254037844386], ...
	'Tag','Axes1Text2', ...
	'Visible','off');
set(get(h2,'Parent'),'ZLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',[0.4967320261437909 1.080459770114942 9.160254037844386], ...
	'Tag','Axes1Text1', ...
	'VerticalAlignment','bottom');
set(get(h2,'Parent'),'Title',h2);
global heditmodel;
heditmodel=[hed hed_a hed_b hed_samp hed_dam];
im=imread('ab','bmp');
axes(hpic);
image(im);
set(hpic,'XTick',[]);
set(hpic,'YTick',[]);
clear im;

elseif(par==1)%exit with change
   global heditmodel;
   str=get(heditmodel(2),'String');
   auxA=str2num(str);
   str=get(heditmodel(3),'String');
   auxB=str2num(str);
   str=get(heditmodel(4),'String');
   auxt=str2num(str);
   str=get(heditmodel(5),'String');
   auxd=str2num(str);
   
   test=0;
   if(isempty(auxd)|isempty(auxt)|isempty(auxA)|isempty(auxB)) test=1;end;
   if(test==0)
	   if(auxd<0) test=1;else auxd=round(auxd);end;
	   if(auxt<0) test=1;end;
   end;
   if(test==0)
      global A B Ts;
      A=[1 auxA];
      B=[];
      for K=0:auxd B=[0 B];end;
      B=[B auxB];
      Ts=auxt;
		%--------------------------------transformation from TF(z^-1) to TF(z)
      %A(z^-1)=a0+a1z^-1+ ... aNaz^-Na ---> A(z)=a0z^Na2 + ...
      nb=length(B);
      na=length(A);
		nBd=nb;
		if(na>nBd)%polynom A has higher order
		   A=A;%nothing to change
		   zr=zeros(1,na-nBd);
		   B=[B zr];%increase order of B
		elseif(nBd>na)
		   B=B;%nothing to change
		   zr=zeros(1,nBd-na);
		   A=[A zr];%increase order of A
		end;
		%adjust length of polynoms
		if(length(B)<length(A))
		   zr=zeros(1,length(A)-length(B));
		   B=[zr B];
		elseif(length(B)>length(A))
		   zr=zeros(1,length(B)-length(A));
		   A=[zr A];
      end;
      
   else
      msgbox('New model is not correct no changes will be done');
   end;
   ch=get(heditmodel(1),'Children');
   for K=2:length(ch) delete(ch(K));end;
   close;
elseif(par==2)%delete function
   global A B Ts;
	clear global heditmodel;
   if(isempty(A)~=1)
	   disp('Current model is:');
	   A,
	   B,
      Ts
      reinit;
   end;
end;
