function initial();

global PRECISION;

echo on,disp('Initialization...');echo off;
%function for setting all variables after load model
global A B;
global Ts;

global PD PDfmin PDfmax PDdmin PDdmax;%polynom of dominant CL poles and ranges of freq and damp
global AP APgama APN APgmin APgmax;%structure about coeff. of aux. mult. pole
global Hs Hsfmin Hsfmax Hsdmin Hsdmax Hspmin Hspmax;
global Hr Hrfmin Hrfmax Hrdmin Hrdmax Hrpmax Hrpmin;
global hchk_syp hchk_sup hbut_flt;%checkboxes for Syp and Sup filters

global Sypf_num Sypf_den Supf_num Supf_den; %numerators and denominators of 2poles/2zeros filters for Syp and Sup 
global Sypf Supf; %flags for the filters
global Sup_filters Syp_filters; %stored structures of the filters

global PAuxiliary;%structure for other auxiliary poles (oscillatory or multiple real)

global R S;
global Wsypu Wsypd Wsup Wsyb fn;

%test of the model order
if(length(A)==2) 
   A=[A 0.01000317];
   msgbox('To denominator of model was added coefficient 0.01z^(-2)');
end;
% removing of a common factor from A and B
%syst=tf(B,A,Ts);
%s2=minreal(syst);
%Bnew=cat(1,s2.num{:});
%Anew=cat(1,s2.den{:});
%if(abs(sum(abs(A))-sum(abs(Anew)))>PRECISION) 
%   msgbox('There was common factor in A and B, it was removed.');
%   A=Anew;
%   B=Bnew;
%end;   


%test order of the dynamics
integrator=0;
Ams=A;
Ams1=A;
rest=A;
[Ams1,rest] = deconv(Ams,[1 -1]) ;


while ((sum(abs(rest))==0)&(length(Ams)>1))
   Ams=Ams1;
   integrator=integrator+1;%%%%%%%%%%%%%%%%% integrator
	[Ams1,R] = deconv(Ams,[1 -1]) ;
end;
ord=size(Ams);
if(ord(2)>2) 
   %determine default dominant poles, aux. multiple pole and their ranges
   [mag,wnall,xiall]=ddamp(Ams,Ts);
   [wnmin,index]=min(wnall);
   [wnmax,index]=max(wnall);
   if abs(wnmin)>1e-6 fnat=wnmin/2/pi;%%%%%%%%%%%%%%%%%natural freq
   else fnat=0.2*0.5/Ts;
   end;
   xi=0.8;%%%%%%%%%%%%%%%%%%%%%%%%damping
elseif(ord(2)<=2)%1st or 0 order
   fnat=0.2*0.5/Ts;
   wnmin=0.2*(2*pi*0.5/Ts);
   xi=0.8;
end;

   PDfmin=1e-15; 
	%if(fnat<0.01) PDfmin=fnat; else PDfmin=0.01; end;
   if(fnat>(0.5/Ts)) fnat=0.5/Ts; wnmin=2*pi*fnat;end;
   PDfmax=0.5/Ts;

   %transform continue->discret
	w=wnmin*Ts*sqrt(1-xi*xi);
	alpha=exp(-xi*wnmin*Ts);
	beta=cos(w);
	delta=sin(w);
	am1=-2*alpha*beta;
	am2=alpha*alpha;
   PD=[1 am1 am2]; %set default polynom of dom. poles
   %   [x,x,wcr,x]=margin(tf(B,A,Ts));%critical frequency

   PDdmin=0.01;
   PDdmax=1;   
echo on,disp('Dominant Poles');echo off;
	   
   %auxiliary poles   
	A2=A;
   B2=B;
   %remove zeros at begining
	while(abs(A2(1))<PRECISION) A2=A2(2:length(A2));end;
   while(abs(B2(1))<PRECISION) B2=B2(2:length(B2));end;
   while(abs(B2(length(B2)))<PRECISION) B2=B2(1:length(B2)-1);end;
   while(abs(A2(length(A2)))<PRECISION) A2=A2(1:length(A2)-1);end;

   
   nmax=length(A2)-1+length(B2)-1;
   nmax,A2,B2,
	APN=nmax-2-1;%nmax-ndom   
   APgama=0.3;
   APgmin=0.0;
   APgmax=0.9;
   
   PAuxiliary=[];
echo on,disp('Auxiliary poles');echo off;
   
   %Hs
   Hs=1;
   Hsfmin=0.01;%wnmin/(2*pi);
   Hsfmax=0.5/Ts;
   Hsdmin=0.001;
   Hsdmax=1;
   Hspmax=0.999;%max of 1st order pole
   Hspmin=-0.999;%min of 1st order pole
   
echo on,disp('Hs');echo off;
   
   %Hr
   Hr=1;
   Hrfmin=0.0093;%wnmin/(2*pi);%min of nat freq
   Hrfmax=0.5/Ts;%max of nat freq
   Hrdmin=0.001;%max of damp
   Hrdmax=1;%min of damp
   Hrpmax=0.999;%max of 1st order pole
   Hrpmin=-0.999;%min of 1st order pole
echo on,disp('Hr');echo off;

	%filters for Syp and Sup
   Sypf_num=1;Sypf_den=1;
   Supf_num=1;Supf_den=1;
   Supf=0;Sypf=0;
   Sup_filters=[];Syp_filters=[];%filter=struct('ft',0,'Mt',0,'xin',0);


   %templates
   nbp=32;
   fn=[1:nbp]'/2/(nbp+1);
	Wsypu=6*ones(size(fn));%6dB
	% compute z
	z=exp(i*2*pi*fn);
	% maximum of the delay margin;
	delmarmax=20*log10(1+1./abs(1-1./z));%condition
	Wsypu=(min([Wsypu';delmarmax']))';
   Wsypd=20*log10(1-1./abs(1-1./z));
   %for s=1:length(k), if(imag(k(s))~=0) k(s)=-25;end;end;
   Wsup=15*ones(size(fn));
   Wsyb=ones(size(fn));
   Wsyb=20*log10(1./abs(1-1./z));
echo on,disp('Templates');echo off;
   
   %solve Bezout equation
rs_compute;
echo on,disp('Controller');echo off;
	   
%reset tracking part
global Am Bm T;%tracking model
Am=[];
Bm=[];
T=[];

%set visible objects
	global h0 haxes_lu haxes_ld haxes_ru hpop_lu hpop_ru hpop_ld;
   global hsli_dpf hdisp_dpf hsli_dpd hdisp_dpd;
	global hsli_aux hdisp_aux hn_aux htxt_n hbut_ap hbut_am;
	global hsli_hsf hdisp_hsf htxt_hsf;
	global hsli_hsd hdisp_hsd htxt_hsd;
	global hsli_hrf hdisp_hrf htxt_hrf;
	global hsli_hrd hdisp_hrd htxt_hrd;
   global hpop_hs hpop_hr;
	global savehld;%structure to save current parameters
	savehld=struct('on',0);
   
   
   %display graphs
   x=get(hpop_lu,'Value');
   set(haxes_lu,'UserData',[]);
   dispgrap(haxes_lu,x);
   x=get(hpop_ld,'Value');
   set(haxes_ld,'UserData',[]);
   dispgrap(haxes_ld,x);
   x=get(hpop_ru,'Value');
   set(haxes_ru,'UserData',[]);
   dispgrap(haxes_ru,x);
   %enable sliders
   %dom. poles freq
   [m,w,xi]=ddamp(PD,Ts);
   set(hsli_dpf,'Min',PDfmin,'Max',PDfmax,'Value',w(1)/(2*pi));
   set(hdisp_dpf,'String',sprintf('%g ',w(1)/(2*pi)));
   set(hsli_dpf,'Enable','on');
   
   %dom. poles damp
   set(hsli_dpd,'Min',PDdmin,'Max',PDdmax,'Value',xi(1));
   set(hdisp_dpd,'String',sprintf('%g ',xi(1)));
   set(hsli_dpd,'Enable','on');
   
   %aux poles
   set(hsli_aux,'Min',APgmin,'Max',APgmax,'Value',APgama);
   if(APN>0) 
		set(hdisp_aux,'String',sprintf('%g ',APgama));
      set(hn_aux,'String',sprintf('%d',APN));
      set(hsli_aux,'Enable','on');
   else 
		set(hdisp_aux,'String','- ');
      set(hn_aux,'String',sprintf('%d',0));
      set(hsli_aux,'Enable','off');
   end;
	nmax=nmax_compute;
   set(htxt_n,'String',sprintf('Free poles: %d',nmax));
         
   %Hs freq
   set(hsli_hsf,'Min',Hsfmin,'Max',Hsfmax,'Value',(Hsfmax-Hsfmin)/2,'Enable','off');
   set(hdisp_hsf,'String','- ');
   %Hs damp
   set(hsli_hsd,'Min',Hsdmin,'Max',Hsdmax,'Value',(Hsdmax-Hsdmin)/2,'Enable','off');
   set(hdisp_hsd,'String','- ');
   %Hr freq
   set(hsli_hrf,'Min',Hrfmin,'Max',Hrfmax,'Value',(Hrfmax-Hrfmin)/2,'Enable','off');
   set(hdisp_hrf,'String','- ');   
   %Hr damp
   set(hsli_hrd,'Min',Hrdmin,'Max',Hrdmax,'Value',(Hrdmax-Hrdmin)/2,'Enable','off');
   set(hdisp_hrd,'String','- ');   
   %popup Hs
   set(hpop_hs,'Enable','on');
   set(hpop_hs,'Value',1);
   
	%popup Hr   
   set(hpop_hr,'Enable','on');
   set(hpop_hr,'Value',1);
   
global htemp hcont htrac hbut_hld hint hui_cl hbut_aux hopn;%enable menu
   set(htemp,'Enable','on');
   set(hcont,'Enable','on');
   set(htrac,'Enable','on');
   set(hbut_ap,'Enable','on');
	set(hbut_am,'Enable','on');   
   set(hbut_hld,'Enable','on');
   set(hint,'Enable','on','Value',0);
   set(hopn,'Enable','on','Value',0);   
   %filters
   set(hchk_sup,'Enable','on');
   set(hchk_syp,'Enable','on');
   set(hbut_flt,'Enable','on');   
   set(hbut_aux,'Enable','on');   
   set(hui_cl,'Enable','on');   
      
   
echo on,disp('Done.');echo off;
