function mainwin(par);
%function for init. of main widow

global PRECISION;
global colorset;

%handlers to objects
global h0 haxes_lu haxes_ld haxes_ru hpop_lu hpop_ru hpop_ld;%figure, axes and popup to axes
global hsli_dpf hdisp_dpf hsli_dpd hdisp_dpd;%sliders for dom. poles
global hsli_aux hdisp_aux hn_aux htxt_n hbut_ap hbut_am;%sliders for aux. poles
global hsli_hsf hdisp_hsf htxt_hsf;%sliders for Hs freq
global hsli_hsd hdisp_hsd htxt_hsd;%sliders for Hs damping
global hsli_hrf hdisp_hrf htxt_hrf;%sliders for Hr freq
global hsli_hrd hdisp_hrd htxt_hrd;%sliders for Hr damping
global hpop_hs hpop_hr;%popups for Hr and Hs
global htemp hcont htrac hui_cl;%uimenus 
global hbut_hld;%button to hold current graph
global hint hopn;%integrator inside Hs, loop opening at 0.5fs
global hchk_syp hchk_sup hbut_flt hbut_aux;%checkboxes for Syp and Sup filters
global modname;

global type;
if(isempty(type)~=1) if(type==1) close(h0);end;end;
type=0;%closed loop window

global savehld;%structure to save current parameters
savehld=struct('on',0);

if par==0%run with initialization
   %important variables
   modname='untitled';
   
	global Ts;%sampling time
	Ts=1;
	global A B;%model
	A=[];B=[];
	global R S; %controller
	R=[];S=[];
	global PD PDfmin PDfmax PDdmin PDdmax;%polynom of dominant CL poles and ranges of freq and damp
	PD=[];PDfmin=0;PDfmax=0;PDdmin=0;PDdmax=0;
	global AP APgama APN APgmin APgmax;%structure about coeff. of aux. mult. pole
	AP=[];APgama=0;APN=0;APgmin=0;APgmax=0;
	global Hs Hsfmin Hsfmax Hsdmin Hsdmax Hspmin Hspmax;
	Hs=[];Hsfmin=0;Hsfmax=0;Hsdmin=0;Hsdmax=0;Hspmin=0;Hspmax=0;
	global Hr Hrfmin Hrfmax Hrdmin Hrdmax Hrpmax Hrpmin;
   Hr=[];Hrfmin=0;Hrfmax=0;Hrdmin=0;Hrdmax=0;Hrpmax=0;Hrpmin=0;
	global Wsypu Wsypd Wsup Wsyb fn;%templates of sensitivity functions
	Wsypu=[];Wsypd=[]; Wsup=[]; Wsyb=[]; fn=[];
   
	global Am Bm TMf TMd TMfmax TMfmin TMdmax TMdmin;%tracking model
	Am=[];
	Bm=[];
   
   global Sypf_num Sypf_den Supf_num Supf_den; %numerators and denominators of 2poles/2zeros filters for Syp and Sup 
   global Sypf Supf; %flags for the filters
   global Sup_filters Syp_filters; %stored structures of the filters

	Sypf_num=1;Sypf_den=1;Supf_num=1;Supf_den=1;Supf=0;Sypf=0;
   Sup_filters=[];Syp_filters=[];%filter=struct('ft',0,'Mt',0,'xin',0);
   
   global PAuxiliary;%structure for other auxiliary poles (oscillatory or multiple real)
   PAuxiliary=[];
   
   global cascad;%if tracking model is in cascade (=1 only one model; =2 two models)
	cascad=1;
	global T;%tracking part of controller
	T=[];
	global xscal yscal;
end;


listfn={'Sup - Input Sensitivity Function','Syp - Output Sensitivity Function', ...
      'Syb - Complementary Sensitivity Function','Closed Loop Pole-Zero Map',...
      'Controller Pole-Zero Map','Step Response for Disturbance p(t)'};
lisths={'1','1st order','2nd order-fn,xi'};
listhr={'1','1st order','2nd order-fn,xi'};
%create window
load poleplace2;

nam=sprintf('Pole Placement Master - CLOSED LOOP BLOCK  ...>> model: %s',modname);
h0 = figure('Color',getfield(colorset,'Background'), ...
	'Colormap',mat0, ...
	'MenuBar','none', ...
	'PointerShapeCData',mat1, ...
   'Position',[100 80 800 600], ...
   'Name',nam, ...
   'Resize','off', ...
   'Deletefcn','quitprog(0);', ...
   'Tag','Fig1');

set(h0,'Units','points');
set(h0,'WindowButtondownfcn','pcursor(1);');
set(h0,'WindowButtonupfcn','pcursor(2);');

%barmenu
h1 = uimenu('Parent',h0, ...
	'Label','&Model', ...
	'Tag','uimenu1');
h2 = uimenu('Parent',h1, ...
	'Label','Load model', ...
	'Tag','&Modeluimenu1');
h3 = uimenu('Parent',h2, ...
   'Label','WinPim format', ...
   'Callback','model(1);', ...
	'Tag','&ModelLoad modeluimenu1');
h3 = uimenu('Parent',h2, ...
   'Label','MATLAB format', ...
   'Callback','model(2);', ...
	'Tag','&ModelLoad modeluimenu2');
h2 = uimenu('Parent',h1, ...
   'Label','Save model', ...
	'Tag','&Modeluimenu2');
h3 = uimenu('Parent',h2, ...
   'Label','WinPim format', ...
   'Callback','model(11);', ...
	'Tag','&ModelSave modeluimenu1');
h3 = uimenu('Parent',h2, ...
   'Label','MATLAB format', ...
   'Callback','model(12);', ...
	'Tag','&ModelSave modeluimenu2');
h2 = uimenu('Parent',h1, ...
   'Label','Edit model', ...
   'Callback','editmod(0);', ...
	'Tag','&Modeluimenu3');
h2 = uimenu('Parent',h1, ...
   'Label','Sampling time', ...
   'CallBack','Model(21);', ...
   'Tag','&Modeluimenu4');
h2 = uimenu('Parent',h1, ...
   'Label','Analysis of model', ...
   'CallBack','change(20);', ...
   'Tag','&Modeluimenu5');
h2 = uimenu('Parent',h1, ...
   'Label','Current Parameter Set', ...
   'Separator','on', ...
   'Tag','modelparam');
h3 = uimenu('Parent',h2, ...
   'Label','Load Parameters without model', ...
   'Callback','parameter(3);', ...
   'Tag','Modelloadpar1');
h3 = uimenu('Parent',h2, ...
   'Label','Load Parameters and model', ...
   'Callback','parameter(1);', ...
	'Tag','Modelloadpar2');
h3 = uimenu('Parent',h2, ...
   'Label','Save Parameters and model', ...
   'Callback','parameter(2);', ...
	'Tag','ModelSavepar');


h1 = uimenu('Parent',h0, ...
   'Label','&Templates', ...
   'Enable','off', ...
	'Tag','uimenu2');
h2 = uimenu('Parent',h1, ...
   'Label','Load templates', ...
   'Callback','templates(51);', ...
	'Tag','Templatesuimenu1');
h2 = uimenu('Parent',h1, ...
   'Label','Save templates', ...
   'Callback','templates(52);', ...
	'Tag','Templatesuimenu2');
h2 = uimenu('Parent',h1, ...
   'Label','Edit templates', ...
   'Callback','templates(1);', ...
   'Tag','Templatesuimenu3');
htemp=h1;

h1 = uimenu('Parent',h0, ...
   'Label','&Controller', ...
   'Enable','off', ...
	'Tag','uimenu3');
h2 = uimenu('Parent',h1, ...
	'Label','Save controller', ...
   'Tag','&Controlleruimenu1');
h3 = uimenu('Parent',h2, ...
   'Label','WinReg format', ...
   'CallBack','control(2);', ...
	'Tag','&ControllerSubuimenu1');
h3 = uimenu('Parent',h2, ...
   'Label','MATLAB 4 format', ...
   'Callback','control(4);', ...
   'Tag','&ControllerSave controlleruimenu1');
h3 = uimenu('Parent',h2, ...
   'Label','MATLAB 5 format', ...
   'Callback','control(3);', ...
   'Tag','&ControllerSave controlleruimenu1');
hd = uimenu('Parent',h1, ...
   'Label','Display controller', ...
   'CallBack','change(21);', ...
   'Tag','&Controlleruimenu2');
hd = uimenu('Parent',h1, ...
   'Label','Stability Window', ...
   'CallBack','ctrlstabw(0);', ...
	'Tag','&Controlleruimenu3');

hcont=h1;
hui_cl = uimenu('Parent',h0, ...
   'Label','Closed Loop', ...
   'Enable','off', ...
   'Callback','change(22);', ...
	'Tag','uimenu4');

h1 = uimenu('Parent',h0, ...
	'Label','Option', ...
	'Tag','uimenu5');
h2 = uimenu('Parent',h1, ...
   'Label','Scales', ...
   'Callback','scale(1);', ...
   'Tag','optuimenu1');
h2 = uimenu('Parent',h1, ...
   'Label','Colors', ...
   'Callback','color(1);', ...
   'Tag','optuimenu1');

h1 = uimenu('Parent',h0, ...
	'Label','Tools', ...
	'Tag','uimenu5');
h2 = uimenu('Parent',h1, ...
   'Label','Point Cursor', ...
   'Callback','change(81);', ...
   'Tag','optuimenu1');
h2 = uimenu('Parent',h1, ...
   'Label','Zoom', ...
   'Callback','change(82);', ...
   'Tag','optuimenu1');
h2 = uimenu('Parent',h1, ...
   'Label','Figure', ...
   'Callback','change(83);', ...
   'Tag','optuimenu1');


htrac = uimenu('Parent',h0, ...
   'Label','Tracking->>', ...
   'Enable','off', ...
   'CallBack','timwin;', ...
   'Tag','uimenu5');

h1 = uimenu('Parent',h0, ...
	'Label','Help', ...
	'Tag','uimenu4');
h2 = uimenu('Parent',h1, ...
   'Label','Theory', ...
   'Callback','hlp(1);', ...
	'Tag','Helpuimenu1');
h2 = uimenu('Parent',h1, ...
   'Label','About application', ...
   'Callback','hlp(2);', ...
   'Tag','Helpuimenu2');

h1 = uimenu('Parent',h0, ...
   'Label','Quit', ...
   'CallBack','quitprog(1);', ...
   'Tag','uimenu5');

%axes
h1 = axes('Parent',h0, ...
	'Box','on', ...
	'CameraUpVector',[0 1 0], ...
	'CameraUpVectorMode','manual', ...
   'Color',getfield(colorset,'Axes'), ...
   'XGrid','on', ...
   'YGrid','on', ...
	'ColorOrder',mat2, ...
	'Position',[0.055 0.5483333333333333 0.44 0.3933333333333334], ...
   'Tag','Axes_lu', ...
	'Fontsize',8, ...   
	'XColor',[0 0 0], ...
	'YColor',[0 0 0], ...
   'ZColor',[0 0 0]);
haxes_lu=h1;
set(get(h1,'XLabel'),'Fontsize',8);
set(get(h1,'YLabel'),'Fontsize',8);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',mat3, ...
	'Tag','Axes1Text4', ...
	'VerticalAlignment','cap');
set(get(h2,'Parent'),'XLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',[-0.08262108262108261 0.4936170212765957 9.160254037844386], ...
	'Rotation',90, ...
	'Tag','Axes1Text3', ...
	'VerticalAlignment','baseline');
set(get(h2,'Parent'),'YLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','right', ...
	'Position',[-0.1054131054131054 1.14468085106383 9.160254037844386], ...
	'Tag','Axes1Text2', ...
	'Visible','off');
set(get(h2,'Parent'),'ZLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',[0.4985754985754987 1.029787234042553 9.160254037844386], ...
	'Tag','Axes1Text1', ...
	'VerticalAlignment','bottom');
set(get(h2,'Parent'),'Title',h2);

h1 = axes('Parent',h0, ...
	'Box','on', ...
	'CameraUpVector',[0 1 0], ...
	'CameraUpVectorMode','manual', ...
   'Color',getfield(colorset,'Axes'), ...
   'XGrid','on', ...
   'YGrid','on', ...
	'ColorOrder',mat4, ...
	'Position',[0.54875 0.6266666666666667 0.44125 0.315], ...
   'Tag','Axes_ru', ...
	'Fontsize',8, ...   
	'XColor',[0 0 0], ...
	'YColor',[0 0 0], ...
   'ZColor',[0 0 0]);
haxes_ru=h1;
set(get(h1,'XLabel'),'Fontsize',8);
set(get(h1,'YLabel'),'Fontsize',8);
h2 = text('Parent',h1, ...
	'ButtonDownFcn','ctlpanel SelectMoveResize', ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Interruptible','off', ...
	'Position',[0.4971590909090908 -0.1276595744680851 9.160254037844386], ...
	'Tag','Axes1Text4', ...
	'VerticalAlignment','cap');
set(get(h2,'Parent'),'XLabel',h2);
h2 = text('Parent',h1, ...
	'ButtonDownFcn','ctlpanel SelectMoveResize', ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Interruptible','off', ...
	'Position',[-0.08238636363636354 0.4946808510638298 9.160254037844386], ...
	'Rotation',90, ...
	'Tag','Axes1Text3', ...
	'VerticalAlignment','baseline');
set(get(h2,'Parent'),'YLabel',h2);
h2 = text('Parent',h1, ...
	'ButtonDownFcn','ctlpanel SelectMoveResize', ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','right', ...
	'Interruptible','off', ...
	'Position',[-1.221590909090909 1.180851063829787 9.160254037844386], ...
	'Tag','Axes1Text2', ...
	'Visible','off');
set(get(h2,'Parent'),'ZLabel',h2);
h2 = text('Parent',h1, ...
	'ButtonDownFcn','ctlpanel SelectMoveResize', ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Interruptible','off', ...
	'Position',mat5, ...
	'Tag','Axes1Text1', ...
	'VerticalAlignment','bottom');
set(get(h2,'Parent'),'Title',h2);

h1 = axes('Parent',h0, ...
	'Box','on', ...
	'CameraUpVector',[0 1 0], ...
	'CameraUpVectorMode','manual', ...
   'Color',getfield(colorset,'Axes'), ...
   'XGrid','on', ...
   'YGrid','on', ...
	'ColorOrder',mat6, ...
	'Position',[0.05625 0.06333333333333334 0.44 0.395], ...
   'Tag','Axes_ld', ...
	'Fontsize',8, ...   
	'XColor',[0 0 0], ...
	'YColor',[0 0 0], ...
   'ZColor',[0 0 0]);
haxes_ld=h1;
set(get(h1,'XLabel'),'Fontsize',8);
set(get(h1,'YLabel'),'Fontsize',8);
h2 = text('Parent',h1, ...
	'ButtonDownFcn','ctlpanel SelectMoveResize', ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Interruptible','off', ...
	'Position',[0.4985754985754985 -0.101694915254237 9.160254037844386], ...
	'Tag','Axes1Text4', ...
	'VerticalAlignment','cap');
set(get(h2,'Parent'),'XLabel',h2);
h2 = text('Parent',h1, ...
	'ButtonDownFcn','ctlpanel SelectMoveResize', ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Interruptible','off', ...
	'Position',[-0.08262108262108263 0.4957627118644068 9.160254037844386], ...
	'Rotation',90, ...
	'Tag','Axes1Text3', ...
	'VerticalAlignment','baseline');
set(get(h2,'Parent'),'YLabel',h2);
h2 = text('Parent',h1, ...
	'ButtonDownFcn','ctlpanel SelectMoveResize', ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','right', ...
	'Interruptible','off', ...
	'Position',[-0.1111111111111111 2.334745762711865 9.160254037844386], ...
	'Tag','Axes1Text2', ...
	'Visible','off');
set(get(h2,'Parent'),'ZLabel',h2);
h2 = text('Parent',h1, ...
	'ButtonDownFcn','ctlpanel SelectMoveResize', ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Interruptible','off', ...
	'Position',[0.4985754985754985 1.029661016949153 9.160254037844386], ...
	'Tag','Axes1Text1', ...
	'VerticalAlignment','bottom');
set(get(h2,'Parent'),'Title',h2);

%popup for graphs
hpop_ld = uicontrol('Parent',h0, ...
	'Units','points', ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[33 208.5 266.25 15], ...
	'String',listfn, ...
   'Style','popupmenu', ...
   'Callback','change(1);',...
	'Tag','pop_gld', ...
   'Value',2);

hpop_lu = uicontrol('Parent',h0, ...
	'Units','points', ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[31.5 426 266.25 15], ...
	'String',listfn, ...
   'Style','popupmenu', ...
   'Callback','change(2);',...
	'Tag','pop_glu', ...
   'Value',1);

hpop_ru = uicontrol('Parent',h0, ...
	'Units','points', ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[327.75 426 266.25 15], ...
	'String',listfn, ...
   'Style','popupmenu', ...
   'Callback','change(3);',...   
	'Tag','pop_gru', ...
   'Value',3);

%titles
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontSize',10, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[393.75 242.25 120 15], ...
	'String','Closed Loop Poles', ...
	'Style','text', ...
	'Tag','StaticText1');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontSize',10, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[352.5 126.75 201 15], ...
	'String','Fixed Parts of Controller', ...
	'Style','text', ...
   'Tag','StaticText1');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[323.25 232.5 102 15], ...
	'String','Dominant Poles', ...
	'Style','text', ...
	'Tag','StaticText3');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[323.25 180.75 102 15], ...
	'String','Auxiliary Poles', ...
	'Style','text', ...
	'Tag','StaticText3');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[322.5 111.75 102 15], ...
	'String','Hs - fixed part of S', ...
	'Style','text', ...
	'Tag','StaticText3');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[322.5 60 102 15], ...
	'String','Hr - fixed part of R', ...
	'Style','text', ...
	'Tag','StaticText3');


%sliders
hsli_dpf = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
   'ListboxTop',0, ...
   'Enable','off', ...
	'Position',[440.25 216 129 15.75], ...
   'Style','slider', ...
   'Callback','change(11);',...
   'Tag','Slid_dpf');
hdisp_dpf = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',10, ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[370.5 216 65.25 15], ...
	'String','- ', ...
   'Style','pushbutton', ...
   'callback','enterm(51);', ...
	'Tag','disp_dpf');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[323.25 216 45 15], ...
	'String','Nat.freq[Hz]', ...
	'Style','text', ...
   'Tag','StaticText2');

hsli_dpd = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
   'ListboxTop',0, ...
   'Enable','off', ...
	'Position',[440.25 198.75 129 15.75], ...
   'Style','slider', ...
   'Callback','change(12);',...
	'Tag','slid_dpd');
hdisp_dpd = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',10, ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[370.5 198.75 65.25 15], ...
	'String','- ', ...
   'Style','pushbutton', ...
   'callback','enterm(52);', ...
	'Tag','disp_dpd');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[323.25 198.75 45 15], ...
	'String','Damping', ...
	'Style','text', ...
   'Tag','StaticText2');

hsli_aux = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
   'ListboxTop',0, ...
   'Enable','off', ...
   'Position',[440.25 164.25 129 15.75], ...
   'Style','slider', ...
   'Callback','change(13);',...   
	'Tag','slid_auxp');
hdisp_aux = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',10, ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[370.5 164.25 65.25 15], ...
	'String','- ', ...
   'Style','pushbutton', ...
   'callback','enterm(53);', ...
	'Tag','disp_aux');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[323.25 164.25 45 15], ...
	'String','Coeff. gama', ...
	'Style','text', ...
   'Tag','StaticText2');

h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[338.25 143.25 30.75 15], ...
	'String','Order N', ...
	'Style','text', ...
	'Tag','StaticText2');
hn_aux = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[370.5 145.5 24 15], ...
	'String','- ', ...
   'Style','edit', ...
   'Enable','off', ...
	'Tag','gamaN');
hbut_am = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
	'FontSize',12, ...
	'ListboxTop',0, ...
	'Position',[396.75 142.5 18.75 9], ...
   'String','-', ...
   'Enable','off', ...
   'Callback','Change(18);', ...
	'Tag','Pushbutton3');
hbut_ap = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
	'FontName','MS Sans Sherif', ...
	'FontSize',10, ...
	'ListboxTop',0, ...
	'Position',[396.75 152.25 18.75 9], ...
   'String','+', ...
   'Enable','off', ...   
   'Callback','Change(19);', ...   
	'Tag','Pushbutton3');



hsli_hsf = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
   'ListboxTop',0, ...
   'Enable','off', ...
	'Position',[439.5 95.25 129 15.75], ...
   'Style','slider', ...
   'Callback','change(14);',...   
	'Tag','slid_hsf');
hdisp_hsf = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',10, ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[369.75 95.25 65.25 15], ...
   'String','- ', ...
   'callback','enterm(54);',...
	'Style','pushbutton', ...
	'Tag','disp_hsf');
htxt_hsf = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[322.5 96 45 15], ...
	'String','Nat.freq.[Hz]', ...
	'Style','text', ...
	'Tag','txt_hsf');


hsli_hsd = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
   'ListboxTop',0, ...
   'Enable','off', ...
	'Position',[439.5 78 129 15.75], ...
   'Style','slider', ...
   'Callback','change(15);',...   
   'Tag','slid_hsd');
hdisp_hsd = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',10, ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[369.75 78.75 65.25 15], ...
	'String','- ', ...
   'Style','pushbutton', ...
   'callback','enterm(55);',...
	'Tag','disp_hsd');
htxt_hsd = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[323.25 79.5 45 15], ...
   'String','Damping', ...
	'Style','text', ...
   'Tag','txt_hsd');

hsli_hrf = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
   'ListboxTop',0, ...
   'Enable','off', ...
	'Position',[439.5 43.5 129 15.75], ...
   'Style','slider', ...
   'Callback','change(16);',...   
	'Tag','slid_hrf');
hdisp_hrf = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',10, ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[369.75 43.5 65.25 15], ...
   'String','- ', ...
   'callback','enterm(56);',...
	'Style','pushbutton', ...
	'Tag','disp_hrf');
htxt_hrf = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[323.25 42.75 45 15], ...
	'String','Nat.freq.[Hz]', ...
	'Style','text', ...
   'Tag','txt_hrf');

hsli_hrd = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
   'ListboxTop',0, ...
   'Enable','off', ...
	'Position',[439.5 26.25 129 15.75], ...
   'Style','slider', ...
   'Callback','change(17);',...   
   'Tag','slid_hrd');
hdisp_hrd = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',10, ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[369.75 26.25 65.25 15], ...
	'String','- ', ...
   'Style','pushbutton', ...
   'callback','enterm(57);',...
	'Tag','disp_hrd');
htxt_hrd = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[323.25 26.25 45 15], ...
	'String','Damping', ...
	'Style','text', ...
   'Tag','txt_hrd');


hpop_hs = uicontrol('Parent',h0, ...
	'Units','points', ...
   'ListboxTop',0, ...
   'Enable','off', ...
	'Position',[523.5 114 58.5 15], ...
	'String',lisths, ...
   'Style','popupmenu', ...
   'Callback','change(51);',...   
	'Tag','pop_hs', ...
	'Value',1);
hpop_hr = uicontrol('Parent',h0, ...
	'Units','points', ...
   'ListboxTop',0, ...
   'Enable','off', ...
	'Position',[525 60.75 57 15], ...
	'String',listhr, ...
   'Style','popupmenu', ...
   'Callback','change(52);',...   
	'Tag','pop_hr', ...
   'Value',1);

hbut_hld = uicontrol('Parent',h0, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[312 5.25 60 15], ...
   'String','Hold graphs', ...
   'Callback','change(60);', ...
   'Enable','off', ...
   'Tag','holdbutton');

hint = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'ListboxTop',0, ...
	'Position',[440.25 114 57.75 15], ...
   'String','Integrator', ...
   'Callback','change(511);', ...
   'Enable','off', ...
   'Style','checkbox', ...
   'Value',0, ...
   'Tag','Checkbox1');
hopn = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'Callback','change(55);', ...
	'Enable','off', ...
	'ListboxTop',0, ...
	'Position',[440.25 59.25 79.5 15], ...
	'String',' Open Loop: 0.5fs', ...
	'Style','checkbox', ...
	'Tag','Checkbox1');

hchk_sup = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'ListboxTop',0, ...
	'Position',[466.5 6 45 15], ...
   'String','Sup filter', ...
   'Callback','Change(53);', ...
   'Style','checkbox', ...
   'enable','off', ...
	'Tag','Check_Sup');
hchk_syp = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'ListboxTop',0, ...
	'Position',[415.5 6 45 15], ...
   'String','Syp filter', ...
   'Callback','Change(54);', ...
   'Style','checkbox', ...
   'enable','off', ...   
	'Tag','Check_Syp');
hbut_flt = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
	'ListboxTop',0, ...
	'Position',[520.5 6 62 14.25], ...
   'String','Band-stop filters', ...
   'enable','off', ...   
   'Callback','filter_w2(0);', ...
   'Tag','Pushbutton1');
hbut_aux = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
	'ListboxTop',0, ...
   'Position',[520.5 147 62 15], ...
   'Callback','auxpol(0);', ...
   'enable','off', ...
	'String','Other aux. poles', ...
   'Tag','Pushbutton2');
htxt_n = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[458.25 149.25 54 11.25], ...
	'String','Free poles: 0', ...
	'Style','text', ...
	'Tag','StaticText4');




clear mat0 mat1 mat2 mat3 mat4 mat5 mat6 mat7 mat8;

if(par==1)
   reinit;
end;
