function model(par)
%function for handling with models
global A B Ts;
global modname h0;

F_setmod=0;%flag if model was set

if(par==1)%load model in winpim format
   str='Load model in WinPim format';ext='*.mod';
   [file,pathfile]=uigetfile(ext,str);
   name=[pathfile file];
   if(file==0) return;end;
   [A,B,C,na,nb,d,nc,midf]=loadwp(name);
   F_setmod=1;
elseif(par==2)%load model in matlab format
   str='Load model in MATLAB format';ext='*.mat';
   [file,pathfile]=uigetfile(ext,str);
   name=[pathfile file];
   if(file==0) return;end;
   eval(sprintf('load %s A B Ts',name));
   k=size(A);
   if(k(1)>1) A=A(1,:);B=B(1,:);end;%if A is matrix
   F_setmod=1;
elseif(par==11)%save model in winpim format
   if(isempty(A)) return;end;
   str='Save model in WinPim format';ext='*.mod';
   [file,pathfile]=uiputfile(ext,str);
   name=[pathfile file];
   if(file==0) return;end;
   [nummod orderA]=size(A);
	[nummod orderB]=size(B);
	orderA=orderA-1;
	orderB=orderB-1;
	d=min(find(B~=0))-2;
   savewp(name,A,B,0,orderA,orderB-d,d,0,0);
   modname=file;
   set(h0,'name',sprintf('Pole Placement Master - CLOSED LOOP BLOCK  ...>> model: %s',modname));
elseif(par==12)%save model in matlab format
   if(isempty(A)) return;end;
   str='Save model in MATLAB format';ext='*.mat';
   [file,pathfile]=uiputfile(ext,str);
   name=[pathfile file];
   if(file==0) return;end;
   eval(sprintf('save %s A B Ts',name));
   modname=file;
   set(h0,'name',sprintf('Pole Placement Master - CLOSED LOOP BLOCK  ...>> model: %s',modname));
elseif(par==21)%set sampling time
   cll=inputdlg('Ts [sec]:',sprintf('New Sampling Time (current is %g)',Ts));
   aux=str2num(char(cll));
   if(isempty(aux)|(aux<0))
      echo on;disp('Previous value is held.');echo off;
   else
		if(Ts~=aux)      
	      Ts=aux;
         echo on;disp(sprintf('New sampling time Ts=%g sec',Ts));echo off;
         initial;
      end;
   end;
end;

if(F_setmod==1) 
   echo on;disp('Loaded model:');echo off;
   A,
   B,
   Ts,
   echo on;disp('-------------------------------');echo off;
   modname=file;
   set(h0,'name',sprintf('Pole Placement Master - CLOSED LOOP BLOCK  ...>> model: %s',modname));
   initial;
end; %initialize workspace