function scale(par)
%function to change scales for sens. functions
global colorset;

if(par==1)%create window
   global h0 F_lin_log Nf_points;;
   set(h0,'Unit','pixel');
   pmain=get(h0,'Position');
   set(h0,'Unit','point');
   
	ped=[573 457 274 223];
	ped(1)=pmain(1)+(pmain(3)-ped(3))/2;
	ped(2)=pmain(2)+(pmain(4)-ped(4))/2;
	global xscal yscal;

	hz=0;rad=0;rat=0;
	if(xscal==1) hz=1;
	elseif(xscal==2) rad=1;
	else rat=1;
	end;
	db=0;lin=0;
	if(yscal==1) db=1;
	else lin=1;
	end;
   

hw = dialog('Color',getfield(colorset,'Background'), ...
	'MenuBar','none', ...
	'Position',ped, ...
   'Resize','off', ...
   'DeleteFcn','scale(30);', ...
	'Tag','Fig1');
hhz = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'ListboxTop',0, ...
	'Position',[16.5 84.5 69 15], ...
	'String',' Hertz', ...
   'Style','checkbox', ...
   'Callback','scale(11);', ...   
   'Value',hz, ...
	'Tag','Checkbox1');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontSize',10, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[26.25 139.5 156 17.25], ...
	'String','Sensitivity Function Scales', ...
	'Style','text', ...
	'Tag','StaticText1');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[147 12 45 15], ...
   'String','OK', ...
   'CallBack','scale(31)', ...
	'Tag','Pushbutton1');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[76.5 12 45 15], ...
   'String','Cancel', ...
   'CallBack','scale(32);', ...
	'Tag','Pushbutton1');
hrad = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'ListboxTop',0, ...
	'Position',[16.5 65.5 69 15], ...
	'String','rad/sec', ...
   'Style','checkbox', ...
   'Callback','scale(12);', ...   
   'Value',rad, ...
	'Tag','Checkbox1');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[14.25 121.5 81 15], ...
	'String','X axes- frequency', ...
	'Style','text', ...
	'Tag','StaticText2');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[105 121.5 84 15], ...
	'String','Y axes-magnitude', ...
	'Style','text', ...
	'Tag','StaticText2');
hdb = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'ListboxTop',0, ...
	'Position',[107.25 85 69 15], ...
	'String','deciBell', ...
   'Style','checkbox', ...
   'Callback','scale(21);', ...   
   'Value',db, ...
	'Tag','Checkbox1');
hlin = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'ListboxTop',0, ...
	'Position',[107.25 66 69 15], ...
	'String','linear', ...
   'Style','checkbox', ...
   'Callback','scale(22);', ...
   'Value',lin, ...
	'Tag','Checkbox1');
hrat = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'ListboxTop',0, ...
	'Position',[16.5 46.5 69 15], ...
	'String','ratio f/fs', ...
   'Style','checkbox', ...
   'Callback','scale(13);', ...
   'Value',rat, ...
   'Tag','Checkbox1');
hpop_ll = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',[0.831372549019608 0.815686274509804 0.784313725490196], ...
	'ListboxTop',0, ...
	'Position',[15.75 103.5 70.5 15], ...
	'String',{'linear','logarithmic'}, ...
   'Style','popupmenu', ...
	'Tag','PopupMenu1', ...
	'Value',1);
hedt_np = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[16.5 30 45 15], ...
   'Style','edit', ...
   'String',num2str(Nf_points), ...
	'Tag','EditText1');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[63.75 28.5 31.5 15], ...
	'String','points', ...
	'Style','text', ...
	'Tag','StaticText3');


	global hscal; 
   hscal=[hhz hrad hrat hdb hlin hw hpop_ll hedt_np];
   set(hpop_ll,'Value',F_lin_log);

elseif(par==11)%callback hz
   global hscal;
   set(hscal(1),'Value',1);
   set(hscal(2),'Value',0);
   set(hscal(3),'Value',0);
   
elseif(par==12)%callback rad/s
   global hscal;
   set(hscal(1),'Value',0);
   set(hscal(2),'Value',1);
   set(hscal(3),'Value',0);
   
elseif(par==13)%callback f/fs
   global hscal;
   set(hscal(1),'Value',0);
   set(hscal(2),'Value',0);
   set(hscal(3),'Value',1);
   
elseif(par==21)%callback dB
   global hscal;
   set(hscal(4),'Value',1);
   set(hscal(5),'Value',0);
   
elseif(par==22)%callback lin
   global hscal;
   set(hscal(4),'Value',0);
   set(hscal(5),'Value',1);
   
elseif(par==30)%deletefcn
   clear global hscal;
elseif(par==31)%callback OK
   global hscal;
   global xscal yscal F_lin_log Nf_points;
  	if(get(hscal(1),'Value')==1) nxscal=1;end;
  	if(get(hscal(2),'Value')==1) nxscal=2;end;
  	if(get(hscal(3),'Value')==1) nxscal=3;end;
  	if(get(hscal(4),'Value')==1) nyscal=1;end;
   if(get(hscal(5),'Value')==1) nyscal=2;end;
   if(nxscal~=xscal)|(nyscal~=yscal)  
      xscal=nxscal;
      yscal=nyscal;
   end;
   val=str2num(get(hscal(8),'String'));
   if ~isempty(val),
      if round(val)>10, Nf_points=round(val);end;
   end;
   F_lin_log=get(hscal(7),'Value');
   global A;
   if(isempty(A)~=1)
		global h0 haxes_lu haxes_ld haxes_ru hpop_lu hpop_ru hpop_ld;
	   %display graphs
	   x=get(hpop_lu,'Value');
	   dispgrap(haxes_lu,x);
	   x=get(hpop_ld,'Value');
	   dispgrap(haxes_ld,x);
	   x=get(hpop_ru,'Value');
      dispgrap(haxes_ru,x);
   end;
   
   close(hscal(6));
elseif(par==32)%cancel callback
   global hscal
   close(hscal(6));
end;

   
   
   