function t_dispgr(hand,par)
%function to quick display current graph
global colorset;
global A B;
global Ts;
global R S T;
global Am Bm;%tracking model
global cascad;

global h0;
global PRECISION;

if(isempty(A)|isempty(B)|isempty(R)|isempty(S)|isempty(T)) return; end;

%reference signal
den=1;
num=1;
for K=1:cascad
	den=conv(den,Am);
	num=conv(num,Bm);
end;
sys=tf(num,den,Ts);
global hed_tmax;
tmax=str2num(get(hed_tmax,'String'));
if(isempty(tmax)|tmax<=0|tmax>1000)
   tmax=9/(2*pi*0.05/Ts);
   s=sprintf('%g',tmax);
   set(hed_tmax,'String',s);
end;
[ref,tim]=step(sys,tmax);

if(par==0)
   global hdisp_rist hdisp_mos;
   [rr,ss,Paux]=rs_complete;
	den=add(conv(A,ss),conv(B,rr));
	num=conv(B,T);
   resp=filter(num,den,ref);
   %rise time
	inx=find(resp>=0.9);
	if(isempty(inx)) txt=sprintf('>%g',tmax);
	else txt=sprintf('%g',tim(inx(1)));
	end;
	set(hdisp_rist,'String',txt);   
	%max. overshoot
	if (max(resp)>=1) txt=sprintf('%g',(max(resp)-1)*100);
	else txt='<0';
	end;
	set(hdisp_mos,'String',txt);   
   return;
end;

if(par==1)
   [rr,ss,Paux]=rs_complete;
	den=add(conv(A,ss),conv(B,rr));
	num=conv(B,T);
	resp=filter(num,den,ref);
elseif(par==2)
   resp=ref;
elseif(par==3)
   [rr,ss,Paux]=rs_complete;
   den=add(conv(A,ss),conv(B,rr));
	num=conv(A,T);
	resp=filter(num,den,ref);
end;


x=get(hand,'UserData');
if isempty(x) x=-1;end;

if(x(1)==par)%only data change
   set(x(2),'YData',resp);
   set(x(2),'XData',tim);
else%change all
   %change everything
   if(x(1)~=-1) %remove previous graph
      for K=2:length(x) delete(x(K));end;
   end;
   axes(hand);
   cla;
   hs=line('Color',getfield(colorset,'Current'), ...
	'LineStyle','-', ...
	'LineWidth',[0.5], ...
	'Marker','none', ...
	'XData',tim, ...
	'YData',resp,...
   'Parent',[hand]);
      
   set(hand,'UserData',[par hs]);
   set(get(hand,'XLabel'),'String','Time [sec]');
   set(get(hand,'YLabel'),'String','Magnitude');
   set(hand,'XGrid','on','YGrid','on');
   set(hand,'Fontsize',8);
	t_dishld(hand,par);%display held graphs
end;      
   