function [r,s,pax,hsapp,hrapp]=rs_complete;
%function [r,s,pax,hsapp,hrapp]=rs_complete;
%
%evaluates controller R,S and its parameters Hs, Hr, P.
%outputs:
%r ...		controller numerator R
%s ...		controller denominator S
%pax ...		CL poles 
%hsapp ...	controller fixed part Hs
%hrapp ...	controller fixed part Hr

global PD ;%polynom of dominant CL poles and ranges of freq and damp
global AP APN APgama;%structure about coeff. of aux. mult. pole
global Hs ;
global Hr ;
global Sypf_num Sypf_den Supf_num Supf_den; %numerators and denominators of 2poles/2zeros filters for Syp and Sup 
global Sypf Supf; %flags for the filters
global R S;
global A B;
global PAuxiliary;%structure for other auxiliary poles (oscillatory or multiple real)

if(APN==0)
	AP=[1];
else
	k=1; AP=[1 (-1)*APgama];
   while(k<APN) k=k+1;AP=conv(AP,[1 (-1)*APgama]);end;%polynom aux poles
end;

	pa1=evalaux(PAuxiliary);
   P=conv(AP,pa1);
   hsapp=Hs;
   hrapp=Hr;
   Papp=P;
   if Sypf, hsapp=conv(Sypf_num,Hs);Papp=conv(Papp,Sypf_den);end;
   if Supf, hrapp=conv(Supf_num,Hr);Papp=conv(Papp,Supf_den);end;
   
   s=conv(hsapp,S);
   r=conv(hrapp,R);
   pax=Papp;